// Tony Urschler
// October 11, 2021

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <errno.h>
#include <ctype.h>
#include <unistd.h>
#include <signal.h>
#include <sys/shm.h>
#include <sys/stat.h>
#include <sys/types.h>
#include "liblicense.h"

void handle_sigint(int sig);

int main(int argc, char* argv[]) {

    signal(SIGINT, handle_sigint);

    //setting error message
	char errmsgraw[20];
	snprintf(errmsgraw, sizeof(errmsgraw), "%s: Error", argv[0]);
	char* errmsg = errmsgraw + 2;

    //validating parameters
	char* str = argv[1];
	for (int i = 0; str[i] != '\0'; i++) {
		if (isdigit(str[i]) == 0 && str[i] != ' ') {
			errno = EINVAL;
			perror(errmsg);
			exit(EXIT_FAILURE);
		}
	}
	str = argv[2];
	for (int i = 0; str[i] != '\0'; i++) {
		if (isdigit(str[i]) == 0 && str[i] != ' ') {
			errno = EINVAL;
			perror(errmsg);
			exit(EXIT_FAILURE);
		}
	}
	str = argv[3];
	for (int i = 0; str[i] != '\0'; i++) {
		if (isdigit(str[i]) == 0 && str[i] != ' ') {
			errno = EINVAL;
			perror(errmsg);
			exit(EXIT_FAILURE);
		}
	}

	//storing paramters
	int sleeptime = atoi(argv[1]);
	int repeatfactor = atoi(argv[2]);
	int semid = atoi(argv[3]);

	//going through loop and writing to file
	for (int i = 0; i < repeatfactor; i++) {
		sleep(sleeptime);
		time_t now;
		time(&now);
		struct tm* tp = localtime(&now);
		char* msg; char buff[50];
		sprintf(buff, "TIME: %.2d:%.2d:%.2d PID: %d ITERATION#: %d of %d",
				tp->tm_hour, tp->tm_min, tp->tm_sec,
				(int)getpid(), i+1, repeatfactor);
		msg = buff;
		logmsg(semid, msg);
	}
	exit(0);
}

void handle_sigint(int sig) {
    exit(0);
}
